/* Type information for dependence.c.
   Copyright (C) 2002 Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

GCC is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

/* This file is machine generated.  Do not edit.  */

void
gt_ggc_mx_induction (x_p)
      void *x_p;
{
  struct induction * const x = (struct induction *)x_p;
  if (ggc_test_and_set_mark (x))
    {
      gt_ggc_m_9induction ((*x).next);
    }
}

void
gt_ggc_mx_loop (x_p)
      void *x_p;
{
  struct loop * const x = (struct loop *)x_p;
  if (ggc_test_and_set_mark (x))
    {
      gt_ggc_m_9tree_node ((*x).outer_loop);
      gt_ggc_m_9tree_node ((*x).containing_loop);
      gt_ggc_m_4loop ((*x).next_nest);
      gt_ggc_m_9induction ((*x).ind);
    }
}

void
gt_ggc_mx_dependence (x_p)
      void *x_p;
{
  struct dependence * const x = (struct dependence *)x_p;
  if (ggc_test_and_set_mark (x))
    {
      gt_ggc_m_9tree_node ((*x).source);
      gt_ggc_m_9tree_node ((*x).destination);
      gt_ggc_m_10dependence ((*x).next);
    }
}

void
gt_ggc_mx_def_use (x_p)
      void *x_p;
{
  struct def_use * const x = (struct def_use *)x_p;
  if (ggc_test_and_set_mark (x))
    {
      gt_ggc_m_9tree_node ((*x).outer_loop);
      gt_ggc_m_9tree_node ((*x).containing_loop);
      gt_ggc_m_9tree_node ((*x).expression);
      gt_ggc_m_7def_use ((*x).next);
      gt_ggc_m_10dependence ((*x).dep);
    }
}

void
gt_ggc_m_P9induction15varray_head_tag (x_p)
      void *x_p;
{
  struct varray_head_tag * const x = (struct varray_head_tag *)x_p;
  if (ggc_test_and_set_mark (x))
    {
      switch ((*x).type)
        {
        case VARRAY_DATA_C:
          break;
        case VARRAY_DATA_UC:
          break;
        case VARRAY_DATA_S:
          break;
        case VARRAY_DATA_US:
          break;
        case VARRAY_DATA_I:
          break;
        case VARRAY_DATA_U:
          break;
        case VARRAY_DATA_L:
          break;
        case VARRAY_DATA_UL:
          break;
        case VARRAY_DATA_HINT:
          break;
        case VARRAY_DATA_UHINT:
          break;
        case VARRAY_DATA_GENERIC:
          {
            size_t i10;
            for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
              gt_ggc_m_9induction ((*x).data.generic[i10]);
            }
          }
          break;
        case VARRAY_DATA_CPTR:
          {
            size_t i11;
            for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
            }
          }
          break;
        case VARRAY_DATA_RTX:
          {
            size_t i12;
            for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
              gt_ggc_m_7rtx_def ((*x).data.rtx[i12]);
            }
          }
          break;
        case VARRAY_DATA_RTVEC:
          {
            size_t i13;
            for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
              gt_ggc_m_9rtvec_def ((*x).data.rtvec[i13]);
            }
          }
          break;
        case VARRAY_DATA_TREE:
          {
            size_t i14;
            for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
              gt_ggc_m_9tree_node ((*x).data.tree[i14]);
            }
          }
          break;
        case VARRAY_DATA_BITMAP:
          {
            size_t i15;
            for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
              gt_ggc_m_15bitmap_head_def ((*x).data.bitmap[i15]);
            }
          }
          break;
        case VARRAY_DATA_CONST_EQUIV:
          {
            size_t i16;
            for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
              gt_ggc_m_7rtx_def ((*x).data.const_equiv[i16].rtx);
            }
          }
          break;
        case VARRAY_DATA_TE:
          {
            size_t i17;
            for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
              gt_ggc_m_8elt_list ((*x).data.te[i17]);
            }
          }
          break;
        default:
          break;
        }
    }
}

void
gt_ggc_m_P4loop15varray_head_tag (x_p)
      void *x_p;
{
  struct varray_head_tag * const x = (struct varray_head_tag *)x_p;
  if (ggc_test_and_set_mark (x))
    {
      switch ((*x).type)
        {
        case VARRAY_DATA_C:
          break;
        case VARRAY_DATA_UC:
          break;
        case VARRAY_DATA_S:
          break;
        case VARRAY_DATA_US:
          break;
        case VARRAY_DATA_I:
          break;
        case VARRAY_DATA_U:
          break;
        case VARRAY_DATA_L:
          break;
        case VARRAY_DATA_UL:
          break;
        case VARRAY_DATA_HINT:
          break;
        case VARRAY_DATA_UHINT:
          break;
        case VARRAY_DATA_GENERIC:
          {
            size_t i10;
            for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
              gt_ggc_m_4loop ((*x).data.generic[i10]);
            }
          }
          break;
        case VARRAY_DATA_CPTR:
          {
            size_t i11;
            for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
            }
          }
          break;
        case VARRAY_DATA_RTX:
          {
            size_t i12;
            for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
              gt_ggc_m_7rtx_def ((*x).data.rtx[i12]);
            }
          }
          break;
        case VARRAY_DATA_RTVEC:
          {
            size_t i13;
            for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
              gt_ggc_m_9rtvec_def ((*x).data.rtvec[i13]);
            }
          }
          break;
        case VARRAY_DATA_TREE:
          {
            size_t i14;
            for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
              gt_ggc_m_9tree_node ((*x).data.tree[i14]);
            }
          }
          break;
        case VARRAY_DATA_BITMAP:
          {
            size_t i15;
            for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
              gt_ggc_m_15bitmap_head_def ((*x).data.bitmap[i15]);
            }
          }
          break;
        case VARRAY_DATA_CONST_EQUIV:
          {
            size_t i16;
            for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
              gt_ggc_m_7rtx_def ((*x).data.const_equiv[i16].rtx);
            }
          }
          break;
        case VARRAY_DATA_TE:
          {
            size_t i17;
            for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
              gt_ggc_m_8elt_list ((*x).data.te[i17]);
            }
          }
          break;
        default:
          break;
        }
    }
}

void
gt_ggc_m_P10dependence15varray_head_tag (x_p)
      void *x_p;
{
  struct varray_head_tag * const x = (struct varray_head_tag *)x_p;
  if (ggc_test_and_set_mark (x))
    {
      switch ((*x).type)
        {
        case VARRAY_DATA_C:
          break;
        case VARRAY_DATA_UC:
          break;
        case VARRAY_DATA_S:
          break;
        case VARRAY_DATA_US:
          break;
        case VARRAY_DATA_I:
          break;
        case VARRAY_DATA_U:
          break;
        case VARRAY_DATA_L:
          break;
        case VARRAY_DATA_UL:
          break;
        case VARRAY_DATA_HINT:
          break;
        case VARRAY_DATA_UHINT:
          break;
        case VARRAY_DATA_GENERIC:
          {
            size_t i10;
            for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
              gt_ggc_m_10dependence ((*x).data.generic[i10]);
            }
          }
          break;
        case VARRAY_DATA_CPTR:
          {
            size_t i11;
            for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
            }
          }
          break;
        case VARRAY_DATA_RTX:
          {
            size_t i12;
            for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
              gt_ggc_m_7rtx_def ((*x).data.rtx[i12]);
            }
          }
          break;
        case VARRAY_DATA_RTVEC:
          {
            size_t i13;
            for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
              gt_ggc_m_9rtvec_def ((*x).data.rtvec[i13]);
            }
          }
          break;
        case VARRAY_DATA_TREE:
          {
            size_t i14;
            for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
              gt_ggc_m_9tree_node ((*x).data.tree[i14]);
            }
          }
          break;
        case VARRAY_DATA_BITMAP:
          {
            size_t i15;
            for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
              gt_ggc_m_15bitmap_head_def ((*x).data.bitmap[i15]);
            }
          }
          break;
        case VARRAY_DATA_CONST_EQUIV:
          {
            size_t i16;
            for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
              gt_ggc_m_7rtx_def ((*x).data.const_equiv[i16].rtx);
            }
          }
          break;
        case VARRAY_DATA_TE:
          {
            size_t i17;
            for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
              gt_ggc_m_8elt_list ((*x).data.te[i17]);
            }
          }
          break;
        default:
          break;
        }
    }
}

void
gt_ggc_m_P7def_use15varray_head_tag (x_p)
      void *x_p;
{
  struct varray_head_tag * const x = (struct varray_head_tag *)x_p;
  if (ggc_test_and_set_mark (x))
    {
      switch ((*x).type)
        {
        case VARRAY_DATA_C:
          break;
        case VARRAY_DATA_UC:
          break;
        case VARRAY_DATA_S:
          break;
        case VARRAY_DATA_US:
          break;
        case VARRAY_DATA_I:
          break;
        case VARRAY_DATA_U:
          break;
        case VARRAY_DATA_L:
          break;
        case VARRAY_DATA_UL:
          break;
        case VARRAY_DATA_HINT:
          break;
        case VARRAY_DATA_UHINT:
          break;
        case VARRAY_DATA_GENERIC:
          {
            size_t i10;
            for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
              gt_ggc_m_7def_use ((*x).data.generic[i10]);
            }
          }
          break;
        case VARRAY_DATA_CPTR:
          {
            size_t i11;
            for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
            }
          }
          break;
        case VARRAY_DATA_RTX:
          {
            size_t i12;
            for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
              gt_ggc_m_7rtx_def ((*x).data.rtx[i12]);
            }
          }
          break;
        case VARRAY_DATA_RTVEC:
          {
            size_t i13;
            for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
              gt_ggc_m_9rtvec_def ((*x).data.rtvec[i13]);
            }
          }
          break;
        case VARRAY_DATA_TREE:
          {
            size_t i14;
            for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
              gt_ggc_m_9tree_node ((*x).data.tree[i14]);
            }
          }
          break;
        case VARRAY_DATA_BITMAP:
          {
            size_t i15;
            for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
              gt_ggc_m_15bitmap_head_def ((*x).data.bitmap[i15]);
            }
          }
          break;
        case VARRAY_DATA_CONST_EQUIV:
          {
            size_t i16;
            for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
              gt_ggc_m_7rtx_def ((*x).data.const_equiv[i16].rtx);
            }
          }
          break;
        case VARRAY_DATA_TE:
          {
            size_t i17;
            for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
              gt_ggc_m_8elt_list ((*x).data.te[i17]);
            }
          }
          break;
        default:
          break;
        }
    }
}

void
gt_pch_nx_induction (x_p)
      void *x_p;
{
  struct induction * const x = (struct induction *)x_p;
  if (gt_pch_note_object (x, x, gt_pch_p_9induction))
    {
      gt_pch_n_S ((*x).variable);
      gt_pch_n_9induction ((*x).next);
    }
}

void
gt_pch_nx_loop (x_p)
      void *x_p;
{
  struct loop * const x = (struct loop *)x_p;
  if (gt_pch_note_object (x, x, gt_pch_p_4loop))
    {
      gt_pch_n_9tree_node ((*x).outer_loop);
      gt_pch_n_9tree_node ((*x).containing_loop);
      gt_pch_n_4loop ((*x).next_nest);
      gt_pch_n_9induction ((*x).ind);
    }
}

void
gt_pch_nx_dependence (x_p)
      void *x_p;
{
  struct dependence * const x = (struct dependence *)x_p;
  if (gt_pch_note_object (x, x, gt_pch_p_10dependence))
    {
      gt_pch_n_9tree_node ((*x).source);
      gt_pch_n_9tree_node ((*x).destination);
      gt_pch_n_10dependence ((*x).next);
    }
}

void
gt_pch_nx_def_use (x_p)
      void *x_p;
{
  struct def_use * const x = (struct def_use *)x_p;
  if (gt_pch_note_object (x, x, gt_pch_p_7def_use))
    {
      gt_pch_n_9tree_node ((*x).outer_loop);
      gt_pch_n_9tree_node ((*x).containing_loop);
      gt_pch_n_9tree_node ((*x).expression);
      gt_pch_n_S ((*x).variable);
      gt_pch_n_7def_use ((*x).next);
      gt_pch_n_10dependence ((*x).dep);
    }
}

void
gt_pch_n_P9induction15varray_head_tag (x_p)
      void *x_p;
{
  struct varray_head_tag * const x = (struct varray_head_tag *)x_p;
  if (gt_pch_note_object (x, x, gt_pch_p_P9induction15varray_head_tag))
    {
      gt_pch_n_S ((*x).name);
      switch ((*x).type)
        {
        case VARRAY_DATA_C:
          break;
        case VARRAY_DATA_UC:
          break;
        case VARRAY_DATA_S:
          break;
        case VARRAY_DATA_US:
          break;
        case VARRAY_DATA_I:
          break;
        case VARRAY_DATA_U:
          break;
        case VARRAY_DATA_L:
          break;
        case VARRAY_DATA_UL:
          break;
        case VARRAY_DATA_HINT:
          break;
        case VARRAY_DATA_UHINT:
          break;
        case VARRAY_DATA_GENERIC:
          {
            size_t i10;
            for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
              gt_pch_n_9induction ((*x).data.generic[i10]);
            }
          }
          break;
        case VARRAY_DATA_CPTR:
          {
            size_t i11;
            for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
              gt_pch_n_S ((*x).data.cptr[i11]);
            }
          }
          break;
        case VARRAY_DATA_RTX:
          {
            size_t i12;
            for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
              gt_pch_n_7rtx_def ((*x).data.rtx[i12]);
            }
          }
          break;
        case VARRAY_DATA_RTVEC:
          {
            size_t i13;
            for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
              gt_pch_n_9rtvec_def ((*x).data.rtvec[i13]);
            }
          }
          break;
        case VARRAY_DATA_TREE:
          {
            size_t i14;
            for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
              gt_pch_n_9tree_node ((*x).data.tree[i14]);
            }
          }
          break;
        case VARRAY_DATA_BITMAP:
          {
            size_t i15;
            for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
              gt_pch_n_15bitmap_head_def ((*x).data.bitmap[i15]);
            }
          }
          break;
        case VARRAY_DATA_CONST_EQUIV:
          {
            size_t i16;
            for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
              gt_pch_n_7rtx_def ((*x).data.const_equiv[i16].rtx);
            }
          }
          break;
        case VARRAY_DATA_TE:
          {
            size_t i17;
            for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
              gt_pch_n_8elt_list ((*x).data.te[i17]);
            }
          }
          break;
        default:
          break;
        }
    }
}

void
gt_pch_n_P4loop15varray_head_tag (x_p)
      void *x_p;
{
  struct varray_head_tag * const x = (struct varray_head_tag *)x_p;
  if (gt_pch_note_object (x, x, gt_pch_p_P4loop15varray_head_tag))
    {
      gt_pch_n_S ((*x).name);
      switch ((*x).type)
        {
        case VARRAY_DATA_C:
          break;
        case VARRAY_DATA_UC:
          break;
        case VARRAY_DATA_S:
          break;
        case VARRAY_DATA_US:
          break;
        case VARRAY_DATA_I:
          break;
        case VARRAY_DATA_U:
          break;
        case VARRAY_DATA_L:
          break;
        case VARRAY_DATA_UL:
          break;
        case VARRAY_DATA_HINT:
          break;
        case VARRAY_DATA_UHINT:
          break;
        case VARRAY_DATA_GENERIC:
          {
            size_t i10;
            for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
              gt_pch_n_4loop ((*x).data.generic[i10]);
            }
          }
          break;
        case VARRAY_DATA_CPTR:
          {
            size_t i11;
            for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
              gt_pch_n_S ((*x).data.cptr[i11]);
            }
          }
          break;
        case VARRAY_DATA_RTX:
          {
            size_t i12;
            for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
              gt_pch_n_7rtx_def ((*x).data.rtx[i12]);
            }
          }
          break;
        case VARRAY_DATA_RTVEC:
          {
            size_t i13;
            for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
              gt_pch_n_9rtvec_def ((*x).data.rtvec[i13]);
            }
          }
          break;
        case VARRAY_DATA_TREE:
          {
            size_t i14;
            for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
              gt_pch_n_9tree_node ((*x).data.tree[i14]);
            }
          }
          break;
        case VARRAY_DATA_BITMAP:
          {
            size_t i15;
            for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
              gt_pch_n_15bitmap_head_def ((*x).data.bitmap[i15]);
            }
          }
          break;
        case VARRAY_DATA_CONST_EQUIV:
          {
            size_t i16;
            for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
              gt_pch_n_7rtx_def ((*x).data.const_equiv[i16].rtx);
            }
          }
          break;
        case VARRAY_DATA_TE:
          {
            size_t i17;
            for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
              gt_pch_n_8elt_list ((*x).data.te[i17]);
            }
          }
          break;
        default:
          break;
        }
    }
}

void
gt_pch_n_P10dependence15varray_head_tag (x_p)
      void *x_p;
{
  struct varray_head_tag * const x = (struct varray_head_tag *)x_p;
  if (gt_pch_note_object (x, x, gt_pch_p_P10dependence15varray_head_tag))
    {
      gt_pch_n_S ((*x).name);
      switch ((*x).type)
        {
        case VARRAY_DATA_C:
          break;
        case VARRAY_DATA_UC:
          break;
        case VARRAY_DATA_S:
          break;
        case VARRAY_DATA_US:
          break;
        case VARRAY_DATA_I:
          break;
        case VARRAY_DATA_U:
          break;
        case VARRAY_DATA_L:
          break;
        case VARRAY_DATA_UL:
          break;
        case VARRAY_DATA_HINT:
          break;
        case VARRAY_DATA_UHINT:
          break;
        case VARRAY_DATA_GENERIC:
          {
            size_t i10;
            for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
              gt_pch_n_10dependence ((*x).data.generic[i10]);
            }
          }
          break;
        case VARRAY_DATA_CPTR:
          {
            size_t i11;
            for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
              gt_pch_n_S ((*x).data.cptr[i11]);
            }
          }
          break;
        case VARRAY_DATA_RTX:
          {
            size_t i12;
            for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
              gt_pch_n_7rtx_def ((*x).data.rtx[i12]);
            }
          }
          break;
        case VARRAY_DATA_RTVEC:
          {
            size_t i13;
            for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
              gt_pch_n_9rtvec_def ((*x).data.rtvec[i13]);
            }
          }
          break;
        case VARRAY_DATA_TREE:
          {
            size_t i14;
            for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
              gt_pch_n_9tree_node ((*x).data.tree[i14]);
            }
          }
          break;
        case VARRAY_DATA_BITMAP:
          {
            size_t i15;
            for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
              gt_pch_n_15bitmap_head_def ((*x).data.bitmap[i15]);
            }
          }
          break;
        case VARRAY_DATA_CONST_EQUIV:
          {
            size_t i16;
            for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
              gt_pch_n_7rtx_def ((*x).data.const_equiv[i16].rtx);
            }
          }
          break;
        case VARRAY_DATA_TE:
          {
            size_t i17;
            for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
              gt_pch_n_8elt_list ((*x).data.te[i17]);
            }
          }
          break;
        default:
          break;
        }
    }
}

void
gt_pch_n_P7def_use15varray_head_tag (x_p)
      void *x_p;
{
  struct varray_head_tag * const x = (struct varray_head_tag *)x_p;
  if (gt_pch_note_object (x, x, gt_pch_p_P7def_use15varray_head_tag))
    {
      gt_pch_n_S ((*x).name);
      switch ((*x).type)
        {
        case VARRAY_DATA_C:
          break;
        case VARRAY_DATA_UC:
          break;
        case VARRAY_DATA_S:
          break;
        case VARRAY_DATA_US:
          break;
        case VARRAY_DATA_I:
          break;
        case VARRAY_DATA_U:
          break;
        case VARRAY_DATA_L:
          break;
        case VARRAY_DATA_UL:
          break;
        case VARRAY_DATA_HINT:
          break;
        case VARRAY_DATA_UHINT:
          break;
        case VARRAY_DATA_GENERIC:
          {
            size_t i10;
            for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
              gt_pch_n_7def_use ((*x).data.generic[i10]);
            }
          }
          break;
        case VARRAY_DATA_CPTR:
          {
            size_t i11;
            for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
              gt_pch_n_S ((*x).data.cptr[i11]);
            }
          }
          break;
        case VARRAY_DATA_RTX:
          {
            size_t i12;
            for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
              gt_pch_n_7rtx_def ((*x).data.rtx[i12]);
            }
          }
          break;
        case VARRAY_DATA_RTVEC:
          {
            size_t i13;
            for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
              gt_pch_n_9rtvec_def ((*x).data.rtvec[i13]);
            }
          }
          break;
        case VARRAY_DATA_TREE:
          {
            size_t i14;
            for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
              gt_pch_n_9tree_node ((*x).data.tree[i14]);
            }
          }
          break;
        case VARRAY_DATA_BITMAP:
          {
            size_t i15;
            for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
              gt_pch_n_15bitmap_head_def ((*x).data.bitmap[i15]);
            }
          }
          break;
        case VARRAY_DATA_CONST_EQUIV:
          {
            size_t i16;
            for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
              gt_pch_n_7rtx_def ((*x).data.const_equiv[i16].rtx);
            }
          }
          break;
        case VARRAY_DATA_TE:
          {
            size_t i17;
            for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
              gt_pch_n_8elt_list ((*x).data.te[i17]);
            }
          }
          break;
        default:
          break;
        }
    }
}

void
gt_pch_p_9induction (this_obj, x_p, op, cookie)
      void *this_obj ATTRIBUTE_UNUSED;
      void *x_p;
      gt_pointer_operator op ATTRIBUTE_UNUSED;
      void *cookie ATTRIBUTE_UNUSED;
{
  struct induction * const x ATTRIBUTE_UNUSED = (struct induction *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).variable), cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).next), cookie);
}

void
gt_pch_p_4loop (this_obj, x_p, op, cookie)
      void *this_obj ATTRIBUTE_UNUSED;
      void *x_p;
      gt_pointer_operator op ATTRIBUTE_UNUSED;
      void *cookie ATTRIBUTE_UNUSED;
{
  struct loop * const x ATTRIBUTE_UNUSED = (struct loop *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).outer_loop), cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).containing_loop), cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).next_nest), cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).ind), cookie);
}

void
gt_pch_p_10dependence (this_obj, x_p, op, cookie)
      void *this_obj ATTRIBUTE_UNUSED;
      void *x_p;
      gt_pointer_operator op ATTRIBUTE_UNUSED;
      void *cookie ATTRIBUTE_UNUSED;
{
  struct dependence * const x ATTRIBUTE_UNUSED = (struct dependence *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).source), cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).destination), cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).next), cookie);
}

void
gt_pch_p_7def_use (this_obj, x_p, op, cookie)
      void *this_obj ATTRIBUTE_UNUSED;
      void *x_p;
      gt_pointer_operator op ATTRIBUTE_UNUSED;
      void *cookie ATTRIBUTE_UNUSED;
{
  struct def_use * const x ATTRIBUTE_UNUSED = (struct def_use *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).outer_loop), cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).containing_loop), cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).expression), cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).variable), cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).next), cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).dep), cookie);
}

void
gt_pch_p_P9induction15varray_head_tag (this_obj, x_p, op, cookie)
      void *this_obj ATTRIBUTE_UNUSED;
      void *x_p;
      gt_pointer_operator op ATTRIBUTE_UNUSED;
      void *cookie ATTRIBUTE_UNUSED;
{
  struct varray_head_tag * const x ATTRIBUTE_UNUSED = (struct varray_head_tag *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).name), cookie);
  switch ((*x).type)
    {
    case VARRAY_DATA_C:
      break;
    case VARRAY_DATA_UC:
      break;
    case VARRAY_DATA_S:
      break;
    case VARRAY_DATA_US:
      break;
    case VARRAY_DATA_I:
      break;
    case VARRAY_DATA_U:
      break;
    case VARRAY_DATA_L:
      break;
    case VARRAY_DATA_UL:
      break;
    case VARRAY_DATA_HINT:
      break;
    case VARRAY_DATA_UHINT:
      break;
    case VARRAY_DATA_GENERIC:
      {
        size_t i10;
        for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.generic[i10]), cookie);
        }
      }
      break;
    case VARRAY_DATA_CPTR:
      {
        size_t i11;
        for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.cptr[i11]), cookie);
        }
      }
      break;
    case VARRAY_DATA_RTX:
      {
        size_t i12;
        for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.rtx[i12]), cookie);
        }
      }
      break;
    case VARRAY_DATA_RTVEC:
      {
        size_t i13;
        for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.rtvec[i13]), cookie);
        }
      }
      break;
    case VARRAY_DATA_TREE:
      {
        size_t i14;
        for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.tree[i14]), cookie);
        }
      }
      break;
    case VARRAY_DATA_BITMAP:
      {
        size_t i15;
        for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.bitmap[i15]), cookie);
        }
      }
      break;
    case VARRAY_DATA_CONST_EQUIV:
      {
        size_t i16;
        for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.const_equiv[i16].rtx), cookie);
        }
      }
      break;
    case VARRAY_DATA_TE:
      {
        size_t i17;
        for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.te[i17]), cookie);
        }
      }
      break;
    default:
      break;
    }
}

void
gt_pch_p_P4loop15varray_head_tag (this_obj, x_p, op, cookie)
      void *this_obj ATTRIBUTE_UNUSED;
      void *x_p;
      gt_pointer_operator op ATTRIBUTE_UNUSED;
      void *cookie ATTRIBUTE_UNUSED;
{
  struct varray_head_tag * const x ATTRIBUTE_UNUSED = (struct varray_head_tag *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).name), cookie);
  switch ((*x).type)
    {
    case VARRAY_DATA_C:
      break;
    case VARRAY_DATA_UC:
      break;
    case VARRAY_DATA_S:
      break;
    case VARRAY_DATA_US:
      break;
    case VARRAY_DATA_I:
      break;
    case VARRAY_DATA_U:
      break;
    case VARRAY_DATA_L:
      break;
    case VARRAY_DATA_UL:
      break;
    case VARRAY_DATA_HINT:
      break;
    case VARRAY_DATA_UHINT:
      break;
    case VARRAY_DATA_GENERIC:
      {
        size_t i10;
        for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.generic[i10]), cookie);
        }
      }
      break;
    case VARRAY_DATA_CPTR:
      {
        size_t i11;
        for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.cptr[i11]), cookie);
        }
      }
      break;
    case VARRAY_DATA_RTX:
      {
        size_t i12;
        for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.rtx[i12]), cookie);
        }
      }
      break;
    case VARRAY_DATA_RTVEC:
      {
        size_t i13;
        for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.rtvec[i13]), cookie);
        }
      }
      break;
    case VARRAY_DATA_TREE:
      {
        size_t i14;
        for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.tree[i14]), cookie);
        }
      }
      break;
    case VARRAY_DATA_BITMAP:
      {
        size_t i15;
        for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.bitmap[i15]), cookie);
        }
      }
      break;
    case VARRAY_DATA_CONST_EQUIV:
      {
        size_t i16;
        for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.const_equiv[i16].rtx), cookie);
        }
      }
      break;
    case VARRAY_DATA_TE:
      {
        size_t i17;
        for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.te[i17]), cookie);
        }
      }
      break;
    default:
      break;
    }
}

void
gt_pch_p_P10dependence15varray_head_tag (this_obj, x_p, op, cookie)
      void *this_obj ATTRIBUTE_UNUSED;
      void *x_p;
      gt_pointer_operator op ATTRIBUTE_UNUSED;
      void *cookie ATTRIBUTE_UNUSED;
{
  struct varray_head_tag * const x ATTRIBUTE_UNUSED = (struct varray_head_tag *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).name), cookie);
  switch ((*x).type)
    {
    case VARRAY_DATA_C:
      break;
    case VARRAY_DATA_UC:
      break;
    case VARRAY_DATA_S:
      break;
    case VARRAY_DATA_US:
      break;
    case VARRAY_DATA_I:
      break;
    case VARRAY_DATA_U:
      break;
    case VARRAY_DATA_L:
      break;
    case VARRAY_DATA_UL:
      break;
    case VARRAY_DATA_HINT:
      break;
    case VARRAY_DATA_UHINT:
      break;
    case VARRAY_DATA_GENERIC:
      {
        size_t i10;
        for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.generic[i10]), cookie);
        }
      }
      break;
    case VARRAY_DATA_CPTR:
      {
        size_t i11;
        for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.cptr[i11]), cookie);
        }
      }
      break;
    case VARRAY_DATA_RTX:
      {
        size_t i12;
        for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.rtx[i12]), cookie);
        }
      }
      break;
    case VARRAY_DATA_RTVEC:
      {
        size_t i13;
        for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.rtvec[i13]), cookie);
        }
      }
      break;
    case VARRAY_DATA_TREE:
      {
        size_t i14;
        for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.tree[i14]), cookie);
        }
      }
      break;
    case VARRAY_DATA_BITMAP:
      {
        size_t i15;
        for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.bitmap[i15]), cookie);
        }
      }
      break;
    case VARRAY_DATA_CONST_EQUIV:
      {
        size_t i16;
        for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.const_equiv[i16].rtx), cookie);
        }
      }
      break;
    case VARRAY_DATA_TE:
      {
        size_t i17;
        for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.te[i17]), cookie);
        }
      }
      break;
    default:
      break;
    }
}

void
gt_pch_p_P7def_use15varray_head_tag (this_obj, x_p, op, cookie)
      void *this_obj ATTRIBUTE_UNUSED;
      void *x_p;
      gt_pointer_operator op ATTRIBUTE_UNUSED;
      void *cookie ATTRIBUTE_UNUSED;
{
  struct varray_head_tag * const x ATTRIBUTE_UNUSED = (struct varray_head_tag *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).name), cookie);
  switch ((*x).type)
    {
    case VARRAY_DATA_C:
      break;
    case VARRAY_DATA_UC:
      break;
    case VARRAY_DATA_S:
      break;
    case VARRAY_DATA_US:
      break;
    case VARRAY_DATA_I:
      break;
    case VARRAY_DATA_U:
      break;
    case VARRAY_DATA_L:
      break;
    case VARRAY_DATA_UL:
      break;
    case VARRAY_DATA_HINT:
      break;
    case VARRAY_DATA_UHINT:
      break;
    case VARRAY_DATA_GENERIC:
      {
        size_t i10;
        for (i10 = 0; i10 < (size_t)((*x).num_elements); i10++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.generic[i10]), cookie);
        }
      }
      break;
    case VARRAY_DATA_CPTR:
      {
        size_t i11;
        for (i11 = 0; i11 < (size_t)((*x).num_elements); i11++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.cptr[i11]), cookie);
        }
      }
      break;
    case VARRAY_DATA_RTX:
      {
        size_t i12;
        for (i12 = 0; i12 < (size_t)((*x).num_elements); i12++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.rtx[i12]), cookie);
        }
      }
      break;
    case VARRAY_DATA_RTVEC:
      {
        size_t i13;
        for (i13 = 0; i13 < (size_t)((*x).num_elements); i13++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.rtvec[i13]), cookie);
        }
      }
      break;
    case VARRAY_DATA_TREE:
      {
        size_t i14;
        for (i14 = 0; i14 < (size_t)((*x).num_elements); i14++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.tree[i14]), cookie);
        }
      }
      break;
    case VARRAY_DATA_BITMAP:
      {
        size_t i15;
        for (i15 = 0; i15 < (size_t)((*x).num_elements); i15++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.bitmap[i15]), cookie);
        }
      }
      break;
    case VARRAY_DATA_CONST_EQUIV:
      {
        size_t i16;
        for (i16 = 0; i16 < (size_t)((*x).num_elements); i16++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.const_equiv[i16].rtx), cookie);
        }
      }
      break;
    case VARRAY_DATA_TE:
      {
        size_t i17;
        for (i17 = 0; i17 < (size_t)((*x).num_elements); i17++) {
          if ((void *)(x) == this_obj)
            op (&((*x).data.te[i17]), cookie);
        }
      }
      break;
    default:
      break;
    }
}

/* GC roots.  */

const struct ggc_root_tab gt_ggc_r_gt_dependence_h[] = {
  {
    &induction_chain,
    1,
    sizeof (induction_chain),
    &gt_ggc_m_P9induction15varray_head_tag,
    &gt_pch_n_P9induction15varray_head_tag
  },
  {
    &loop_chain,
    1,
    sizeof (loop_chain),
    &gt_ggc_m_P4loop15varray_head_tag,
    &gt_pch_n_P4loop15varray_head_tag
  },
  {
    &dep_chain,
    1,
    sizeof (dep_chain),
    &gt_ggc_m_P10dependence15varray_head_tag,
    &gt_pch_n_P10dependence15varray_head_tag
  },
  {
    &def_use_chain,
    1,
    sizeof (def_use_chain),
    &gt_ggc_m_P7def_use15varray_head_tag,
    &gt_pch_n_P7def_use15varray_head_tag
  },
  LAST_GGC_ROOT_TAB
};

